local stand = Stand.new();

function set_profile(profile_num)
   stand:write_prw(profile_num << 14);
end

function write_profile(ref, cint, frac, cmod, ctr1, ctr2, lfm1, lfm2, lfm3)
   stand:write_ref(ref);
   stand:write_cint(cint);
   stand:write_frac(frac);
   stand:write_cmod(cmod);
   stand:write_ctr1(ctr1);
   stand:write_ctr2(ctr2);
   stand:write_lfm1(lfm1);
   stand:write_lfm3(lfm3);
   stand:write_lfm2(lfm2);
end

local num_of_profiles = 32;
local profiles_order = {};
for i= 1, num_of_profiles - 1 do
   profiles_order[i] = i;
end

profiles_order[num_of_profiles] = 0;

local f_ref = 100e+6;
local f_pfd = 100e+3;
local frac = 1;
local cint = 38000;
local cmod = 65000;
local sawstep = 4000;
local total_lfm_time = 2; -- The period of lfm
local r = f_ref / f_pfd;
local fracinc = total_lfm_time * f_pfd / sawstep;

for i, profile in ipairs(profiles_order) do
   local f_span = 200e+6 - (6.25e+6 * profile);
   local dfrac = f_span * cmod / (sawstep * f_pfd) * 16;

   set_profile(profile);
   local lfm2 = (sawstep <<  8) | (math.floor(fracinc))

   local lfm3 = 0;
   if i == num_of_profiles then
      lfm3 = (1 << 9) | 0x4;
   else
      lfm3 = (profiles_order[i + 1] << 9) | 0x4;
   end

   write_profile(r, cint, frac, cmod, 0x40610, 0x7, math.floor(dfrac), lfm2, lfm3);
end

