local stand = Stand.new();
local cint = 10001;
local ctr1 = 1 << 9; -- OSEL = 1
local pause = 100;

local f_eps = 50; 
local df = 100e+6;

local amp_0 = -30;
local amp_1 = 5;
local d_amp = 1;

function get_sensitivity(f_0, f_1, prescaler)
   local logfile = io.open("pre" .. prescaler .. ".txt", "w");   
   stand:write_ctr1(ctr1 | (prescaler << 3));
   for f = f_0, f_1, df do
      local amp = amp_0;
      stand:set_level(amp);
      stand.csleep(pause);
      stand:set_frequency(f / 1e+6);
      local res, f_m = stand:get_frequency();
  
      while math.abs(f_m  - f / cint) > f_eps do
         amp = amp + d_amp;
         if amp > amp_1 then
            break;
         end
         stand:set_level(amp);
         stand.csleep(pause);
         res, f_m = stand:get_frequency();
      end
      if amp <= amp_1 then
         logfile:write(string.format("%.1f %2.1f\n", f / 1e+6, amp));
         print(string.format("%.2f %.2f %.2f\n", f_m, f / cint, math.abs(f_m  - f / cint)))
      else
         logfile:write(string.format("%.1f Inf\n", f / 1e+6));
      end
   end   
   logfile:close();
end

stand:write_cint(cint);

-- 1. PRE = 0
get_sensitivity(100e+6, 2000e+6, 0);

-- 2. PRE = 1
amp_0 = -25;
get_sensitivity(2100e+6, 4000e+6, 1);

-- 3. PRE = 2
amp_0 = -20;
get_sensitivity(4100e+6, 6000e+6, 2);





